<template>
  <div>
    <v-row class="ma-0 px-3 roboto" justify="center">
      <v-alert
        v-if="$store.getters['subscription/getValidateSubscription'] == false"
        color="tway-violet"
        dismissible
        outlined
        width="500px"
        icon="mdi-information-outline"
        class="rounded-xl"
        close-icon="mdi-close-circle-outline"
      >
        <span class="font-weight-bold">Revisa el correo</span> de bienvenida que
        te enviamos al contratar el plan. Allí encontrarás
        <span class="font-weight-bold">tu código de descuento</span> exclusivo
        para hacer válido el descuento.
      </v-alert>
    </v-row>
    <div class="text-center mb-6">¡Tu pago se ha realizado con éxito!</div>
    <v-row justify="center">
      <v-img
        :src="require(`@/assets/img/Success-payment.svg`)"
        contain
        max-height="100"
        max-width="150"
      />
    </v-row>
    <div class="text-center roboto text-subtitle-1 mt-6">
      Hemos enviado un comprobante al correo <strong> {{ email }} </strong
      ><br />
      También puedes descargar tu comprobante de pago o verlos en la sección
      <strong> Mis Pagos.</strong>
    </div>
    <v-row justify="center" class="mt-6">
      <div v-if="paymentMethod === 'WEBPAY_PLUS_NORMAL'">
        <webpayPlusResult :transaction-id="transactionId" />
      </div>
      <div v-else-if="paymentMethod === 'PAYPAL_SUBSCRIPTION'">
        <paypalSubscriptionResult />
      </div>
      <div v-else-if="paymentMethod === 'PAYPAL_CHECKOUT'">
        <paypalCheckoutResult />
      </div>
    </v-row>
    <v-row justify="center mt-5">
      <v-btn
        class="tway-violet--text mr-4 roboto"
        large
        color="white"
        text
        :to="{ name: 'home' }"
      >
        VOLVER AL INICIO
      </v-btn>
      <v-btn
        large
        rounded
        color="tway-apple-green"
        class="white--text roboto"
        :to="{ name: 'my-payment' }"
      >
        VER MIS PAGOS
      </v-btn>
    </v-row>
  </div>
</template>

<style lang="scss" scoped>
.title-profile {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;
  color: #212121;
}
.text-profile {
  font-family: Roboto;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 19px;
  color: #757575;
}
</style>
<script>
import webpayPlusResult from "@/views/billing/WebpayPlusResult";
import paypalSubscriptionResult from "@/views/billing/PaypalSubscriptionResult";
import paypalCheckoutResult from "@/views/billing/PaypalCheckoutResult";
import planConstants from "@/utils/planConstants.json";
import subscriptionService from "@/services/subscriptionService";
import CurrentUserService from "@/services/currentUserService";

export default {
  name: "SuccessfulPayment",

  components: {
    webpayPlusResult,
    paypalSubscriptionResult,
    paypalCheckoutResult,
  },

  data: () => ({
    email: "",
    firstName: "",
    planConstants: planConstants,
    user: {
      firstName: "",
    },
    subscription: {
      paymentMethod: "",
      payments: [],
      plan: {
        name: "",
      },
    },
    transactionId: "",
  }),

  created() {
    this.$log.info(
      "received paymentMethod : ",
      this.$route.query.paymentMethod
    );
    this.getCurrenUserData();
    this.token = this.$route.query.token;
    this.action = this.$route.query.action;
    this.transactionId = this.$route.query.transactionId;
    this.paymentMethod = this.$route.query.paymentMethod;
    this.email = localStorage.getItem("userName");

    if (!this.action || !this.token) {
      window.close();
    }
  },

  mounted() {},
  methods: {
    getCurrenUserData() {
      CurrentUserService.currentUserData()
        .then((userData) => (this.user = userData))
        .catch((err) => this.$log.error(err));
    },

    getPdf: function (pdf) {
      subscriptionService
        .getPdf("Comprobante_" + pdf)
        .then(function (response) {
          let blob = new Blob([response.data], { type: "application/pdf" });
          let link = document.createElement("a");
          link.href = window.URL.createObjectURL(blob);
          link.download = "Comprobante " + pdf + ".pdf";
          link.click();
        })
        .catch((err) => this.$log.error("Unexpected error: ", err));
    },
  },
};
</script>
